/*****************************************************************************\

    Filename :           CLRDBF.PRG
    Version / Date :     3.0 / 10.1990

    Language :           CLIPPER 5.0

    Purpose :            CLREPORT - DBF functions

    Author / (C) :	 Huggle / Dr. Huggle & Partner GmbH

\*****************************************************************************/

#include "clrepgen.ch"
#include "atomedit.ch"


function ClrDbf ()

#ifdef GERMAN
  local cHead := "Installierte Dateien"
  local cFoot := "<ins> = Einfgen, <del> = Lschen, <ret> = Edieren"
#else
  local cHead := "Installed files"
  local cFoot := "<ins> = insert, <del> = delete, <ret> = edit"
#endif

  private V_HSTW := "DBF EDIT"

  ClrSelection ({ 5, 8, 21, NIL }, .t., NIL, cHead, cFoot, /* flags */, ;
     V_DBFDATA, /* column head */, ;
     { |aData, n| iif (aData == NIL, Space (60), ;
		       str (n, 2) + "    " + ClrStrRPad (aData[1], 53)) }, ;
     { |nKey, n, nRow, aData| DbfCallback (nKey, n, nRow, aData) })

return NIL


**********< Selection Callback >***********************************************

static func DbfCallback (nKey, n, nRow, aData)

#ifdef GERMAN
  local bQuery := {|| "Definition fr " + AllTrim (aData[n][2]) + " lschen"}
#else
  local bQuery := {|| "Delete definition for " + AllTrim (aData[n][2])}
#endif
  local aNewDbf, lResult := .f.

  do case
    case nKey == K_ENTER	/* edit */
      lResult := DbfMask (aData[n], n)
    case nKey == K_INS			/* append or insert */ 
      aNewDbf := { [], [], [], [], .f., "S", [], [], [], .t., .f., ;
		   [], [], [], [], [], [], [], [], [], [], [], [], ;
		   [], [], [], [], [], [], [], [], [], [], [], [] }

      if ( lResult := DbfMask (aNewDbf, n) )
        ClrAins (aData, n, aNewDbf)	/* append fields from DBF */
        AppeFields (aNewDbf[1], aNewDbf[2])
      end
    case nKey == K_DEL			/* delete */
      if ( lResult := ClrYNQuery (8, 10, .f., NIL, Eval (bQuery)) )
        DelFields (aData[n][2])		/* delete fields from report */
        ClrAdel (aData, n)
      end
    otherwise
      return .f.
  end

  ClrWindow ()				/* close mask window */

return lResult


**********< Mask >*************************************************************

static funct DbfMask (aData, n)

#ifdef GERMAN
  static aIndType := { "Standard  ", "Absteigend", "Unique    " }
  static aRelType := { "Fest       ", "Softseek   ", "Durchsuchen" }
  static aSay := { "Dateiname...........:", "Alias...............:", ;
		   "Index-Dateiname.....:", "Index-Ausdruck......:", ;
		   "Immer reindizieren..:", "Indextyp (S/A/U)....:", ;
		   "Filter-Ausdruck.....:", "Start-Ausdruck......:", ;
		   "Abbruch-Bedingung...:", "Gelschte ignorieren:", ;
		   "Relation-Skip.......:", ;
		   "Relation 1:", "Alias:", "Typ (F/S/D):", ;
		   "Relation 2:", "Alias:", "Typ (F/S/D):", ;
		   "Relation 3:", "Alias:", "Typ (F/S/D):", ;
		   "Relation 4:", "Alias:", "Typ (F/S/D):", ;
		   "Relation 5:", "Alias:", "Typ (F/S/D):", ;
		   "Relation 6:", "Alias:", "Typ (F/S/D):", ;
		   "Relation 7:", "Alias:", "Typ (F/S/D):", ;
		   "Relation 8:", "Alias:", "Typ (F/S/D):" }
  local cHead := "Definition der Datei Nummer " + ltrim (str (n)) + ;
		 " > F10 Liste"
#else
  static aIndType := { "standard  ", "descend   ", "unique    " }
  static aRelType := { "fixed      ", "softseek   ", "comb       " }
  static aSay := { "Filename............:", "Alias...............:", ; 
		   "Index filename......:", "Index expression....:", ; 
		   "Force reindex.......:", "Index-type (S/D/U)..:", ; 
		   "Filter-expression...:", "Start-expression....:", ;
		   "While-expression....:", "Skip deleted........:", ;
		   "Relation-Skip.......:", ;
		   "Relation 1:", "Alias:", "Type  F/S/C:", ;
		   "Relation 2:", "Alias:", "Type  F/S/C:", ;
		   "Relation 3:", "Alias:", "Type  F/S/C:", ;
		   "Relation 4:", "Alias:", "Type  F/S/C:", ;
		   "Relation 5:", "Alias:", "Type  F/S/C:", ;
		   "Relation 6:", "Alias:", "Type  F/S/C:", ;
		   "Relation 7:", "Alias:", "Type  F/S/C:", ;
		   "Relation 8:", "Alias:", "Type  F/S/C:" }
  local cHead := "Definition file number " + ltrim (str (n)) + ;
		 " > F10 Selection"
#endif
  static aName  := { "dbfFile", "dbfAlias", "dbfIname", "dbfIexpr", ;
		     "dbfReindex", "dbfItype", "dbfFor", "dbfStart", ;
		     "dbfWhile", "dbfDeleted", "dbfRskip", ;
		     "dbfRexpr", "dbfRalias", "dbfRtype", ;
		     "dbfRexpr", "dbfRalias", "dbfRtype", ;
		     "dbfRexpr", "dbfRalias", "dbfRtype", ;
		     "dbfRexpr", "dbfRalias", "dbfRtype", ;
		     "dbfRexpr", "dbfRalias", "dbfRtype", ;
		     "dbfRexpr", "dbfRalias", "dbfRtype", ;
		     "dbfRexpr", "dbfRalias", "dbfRtype", ;
		     "dbfRexpr", "dbfRalias", "dbfRtype" }
  static aCoord := { {  1, 1 }, {  2,  1 }, {  3,  1 }, ;
		     {  4, 1 }, {  5,  1 }, {  5, 39 }, ;
		     {  6,  1 }, ;
		     ;
		     {  8, 1 }, {  9,  1 }, { 10,  1 }, { 10, 39 }, ;
		     ;
		     { 12, 1 }, { 12, 34 }, { 12, 52 }, ;
		     { 13, 1 }, { 13, 34 }, { 13, 52 }, ;
		     { 14, 1 }, { 14, 34 }, { 14, 52 }, ;
		     { 15, 1 }, { 15, 34 }, { 15, 52 }, ;
		     { 16, 1 }, { 16, 34 }, { 16, 52 }, ;
		     { 17, 1 }, { 17, 34 }, { 17, 52 }, ;
		     { 18, 1 }, { 18, 34 }, { 18, 52 }, ;
		     { 19, 1 }, { 19, 34 }, { 19, 52 } }
  local aPic    := { "@!S54", "@!", "@!S54", "@S54", NIL, aIndType, "@S54", ;
		     "@S54", "@S54", NIL, NIL, ;
		     "@S18", "@!", aRelType, "@S18", "@!", aRelType, ;
		     "@S18", "@!", aRelType, "@S18", "@!", aRelType, ;
		     "@S18", "@!", aRelType, "@S18", "@!", aRelType, ;
		     "@S18", "@!", aRelType, "@S18", "@!", aRelType }
  local bWhen   := { |xValue, g, aInput, n| DbfWhen (xValue, g, aInput, n) }
  local aWhen   := { .t., bWhen, .t., .t., .t., .t., .t., ;
		     n == 1, n == 1, n == 1, n == 1, ;
                     .t., bWhen, bWhen, .t., bWhen, bWhen, ;
                     .t., bWhen, bWhen, .t., bWhen, bWhen, ;
                     .t., bWhen, bWhen, .t., bWhen, bWhen, ;
                     .t., bWhen, bWhen, .t., bWhen, bWhen }
  local bValid  := { |xValue, g, aInput, i| DbfValid (xValue, g, aInput, n) }
  local bList   := { |xValue, g, aInput, n| DbfList (xValue, g, aInput) }

  local lStored, i, aFlags

  /* prepare data */
  aData[1] := ClrStrRPad (aData[1], 70)			// filename
  aData[2] := ClrStrRPad (aData[2],  8)			// alias
  aData[3] := ClrStrRPad (aData[3], 70)			// index file
  aData[4] := ClrStrRPad (aData[4], 70)			// index expr
							// reindex
  aData[6] := __repXchf ("I", 1, aData[6])		// index type
  aData[7] := ClrStrRPad (aData[7], 70)			// for
  aData[8] := ClrStrRPad (aData[8], 70)			// start
  aData[9] := ClrStrRPad (aData[9], 70)			// while
							// deleted
							// skip rela
  for i := 12 to 35 step 3
    aData[i]     = ClrStrRPad (aData[i], 70)		// relation expr
    aData[i + 1] = ClrStrRPad (aData[i + 1], 8)		// relation alias
    aData[i + 2] = __repXchf ("T", 1, aData[i + 2])	// relation type 
  next

  aFlags := iif (n == 1, ;
		 { {  7, 0, Replicate ("", 78) }, ;
		   { 11, 0, Replicate ("", 78) } }, ;
		 { {  9, 0, Replicate ("", 78) } })
  
  /* read data */
  lStored := ClrMask ({ 1, 0, 23, 79 }, .f., NIL /* color */, cHead, ;
    		      NIL /* foot */, aFlags, aData, aName, aWhen, ;
		      aCoord, aSay, aPic, bValid, bList)
  
  /* restore data */
  aData[1] := AllTrim (aData[1])			// filename
  aData[2] := AllTrim (aData[2])			// alias
  aData[3] := AllTrim (aData[3])			// index file
  aData[4] := AllTrim (aData[4])			// index expr
							// reindex
  aData[6] := __repXchf ("I", 2, aData[6])		// index type
  aData[7] := AllTrim (aData[7])			// for
  aData[8] := AllTrim (aData[8])			// start
  aData[9] := AllTrim (aData[9])			// while
							// deleted
							// skip rela
  for i := 12 to 35 step 3
    aData[i]     = AllTrim (aData[i])			// relation expr
    aData[i + 1] = AllTrim (aData[i + 1])		// relation alias
    aData[i + 2] = __repXchf ("T", 2, aData[i + 2])	// relation type 
  next
  
return lStored


**********< When >*************************************************************

static func DbfWhen (xValue, g, aInput, n)

  local lResult := .t.

  do case
    case g:name == "dbfAlias"		/* carry alias */
      if ( Empty (xValue) )
        g:varPut (ClrPathExp (aInput[1], 3)) ; end
    case g:name == "dbfRalias"
      if ( !(lResult := ! Empty (aInput[n - 1])) )
        g:varPut ([]) ; end
    case g:name == "dbfRtype"
      if ( !(lResult := ! Empty (aInput[n - 2])) )
        g:varPut ([]) ; end
  end

return lResult


**********< Valid >************************************************************

static func DbfValid (xValue, g, aInput, nIndex)

#ifdef GERMAN
  static cError1 := "Aliasname mu angegeben werden", ;
	 cError2 := "Syntaxfehler im Ausdruck", ;
	 cError3 := "Ungltiger Aliasname fr Clipper", ;
	 cError4 := "Aliasname bereits vergeben"
#else
  static cError1 := "You must specify an alias name", ;
	 cError2 := "Syntax error in expression", ;
	 cError3 := "Invalid alias name", ;
	 cError4 := "Alias name already used"
#endif
  local cError

  do case
    case g:name == "dbfAlias"
      if ( Empty (xValue := AllTrim (xValue)) )
        g:varPut (ClrPathExp (aInput[1], 4))
        cError := cError1
      elseif ( Val (xValue := Upper (xValue)) != 0 .or. ;
	       ! Empty (StrChRepl (xValue, ;
				   "ABCDEFGHIJKLMNOPQRSTUVWXYZ1234567890_", ;
				   "                                     ")) )
        cError := cError3
      else
        AEval (m->V_DBFDATA, ;
           { |aDbf,i| cError := ;
                iif (i != nIndex .and. ;
                     xValue == Upper (AllTrim (aDbf[2])), cError4, cError) })
      end
    case g:name == "dbfRalias"
      return ! Empty (xValue)
    case g:name == "dbfIexpr" .or. g:name == "dbfFor" .or. ;
         g:name == "dbfStart" .or. g:name == "dbfWhile" .or. ;
	 g:name == "dbfRexpr"		/* Clipper bug */
      if ( ! ClrType (xValue) )
        cError := cError2 ; end
  end

  if ( cError != NIL ) ; ClrMessage (cError, 1) ; end

return cError == NIL


**********< Selections F10 >***************************************************

static func DbfList (xValue, g, aInput)

#ifdef GERMAN
  static cHead := "Verwendete Aliasnamen"
#else
  static cHead := "Installed aliases"
#endif
  local nChoice, cChoice, aAliases := {}, xResult

  do case
    case g:name == "dbfFile"			/* list directory */
      if ( ! Empty (cChoice := ClrSDir ("*.DBF")) )
        xResult := cChoice ; end

    case g:name == "dbfIname"			/* list directory */
      if ( ! Empty (cChoice := ClrSDir ("*" + IndexExt())) )
        xResult := cChoice ; end

    case g:name == "dbfAlias" .or. 		/* alias list */ ;
	 g:name == "dbfRalias"
      AEval (m->V_DBFDATA, { |aDbf| Aadd (aAliases, aDbf[2]) })

      if ( (nChoice := ClrAchoice ({ 4, 45, NIL, NIL }, .t., /* color */, ;
			  cHead, /* foot */, /* flags */, aAliases)) != 0 ;
	   .and. g:name == "dbfRalias" )
        xResult := aAliases[nChoice] ; end

    case g:name == "dbfIexpr" .or. 		/* list structure */ ;
	 g:name == "dbfFor" .or. g:name == "dbfStart" .or. ;
	 g:name == "dbfWhile" .or. g:name == "dbfRexpr"
      if ( (cChoice := FieldSelect (aInput[1] /* filename */)) != NIL )
        g:varPut (Stuff (xValue, g:pos, 0, cChoice)) ; end
  end

return xResult


**********< Supplement Functions >*********************************************

static func DelFields (cAlias)		/* delete fields from report */

#ifdef GERMAN
  static cQuery := "Felder aus Reportdefinition lschen", ;
	 cMess  := "Felder werden aus der Reportdefinition entfernt"
#else
  static cQuery := "Remove fields from report", ;
         cMess  := "Removing fields"
#endif
  local i := 1

  if ( ! Empty (cAlias := Trim (cAlias)) )
    if ( ClrYNQuery (12, 18, .t., NIL, cQuery) )
      ClrMessage (cMess, 3)

      while ( i <= len (V_FIELDPOS) )
        REPORT->(Go (V_FIELDPOS[i]))
        if ( Trim (REPORT->dbf_alias) == cAlias )
          __repExec (_EXEC_REPLATOM, i)
        else
          ++i
        end
      end

      REPORT->(Del (.f., Trim (FIELD->dbf_alias) == cAlias))

      ClrWindow ()
    end
  end

return NIL


static func AppeFields (cFile, cAlias)	/* Append fields from DBF */

#ifdef GERMAN
  static cQuery := "Felder in Report bernehmen", ;
	 cMess  := "Felder werden angefgt"
#else
  static cQuery := "Append fields to report", ;
	 cMess  := "Appending fields"
#endif
  local aStru, aFld, i

  if ( ClrYNQuery (NIL, NIL, .t., NIL, cQuery, .t.) )
    if ( (aStru := ReadStructure (cFile)) != NIL )
      ClrMessage (cMess, 3)

      for i := 1 to len (aStru)
        aFld := aStru[i]

        REPORT->(Append (NIL, ;
	   {|| FIELD->report     := m->V_RNAME, ;
	       FIELD->field_name := Lower (cAlias) + '@' + ;
				    Lower (aFld[DBS_NAME]), ;
	       FIELD->field_expr := cAlias + "->" + aFld[DBS_NAME], ;
	       FIELD->field_len  := aFld[DBS_LEN], ;
	       FIELD->field_dec  := aFld[DBS_DEC], ;
	       FIELD->field_type := aFld[DBS_TYPE], ;
	       FIELD->dbf_alias  := cAlias, ;
	       FIELD->form_opt   := ;
		  iif (aFld[DBS_TYPE] == "N", "R", " ") }))
      next

      ClrWindow ()
    end
  end

return NIL


static func FieldSelect (cFile)		/* select field name */

#ifdef GERMAN
  static cHead := "Auswahl Datenbankfeld"
#else
  static cHead := "Field Selection"
#endif
  local aStru, xFx := {}, nChoice, cResult

  if ( (aStru := ReadStructure (cFile)) != NIL )
    AEval (aStru, ;
	   { |aFld| aadd (xFx, ;
			  ClrStrRPad (aFld[DBS_NAME], 12) + aFld[DBS_TYPE] + ;
			  str (aFld[DBS_LEN], 5) + str (aFld[DBS_DEC], 4)) })

    if ( (nChoice := ClrAchoice ({ 4, 45, NIL, NIL }, .t., CLRCOLOR[_C_LIST],;
				 cHead, /* foot */, /* flags */, xFx)) != 0 )
      cResult := aStru[nChoice][DBS_NAME] ; end
  end

return cResult


static func ReadStructure (cFile)	/* read DBF structure */

#ifdef GERMAN
  local cError := "Datei " + ClrPathExp (cFile, 4) + " nicht gefunden", ;
	cMess  := "Dateistrukur wird gelesen"
#else
  local cError := "File " + ClrPathExp (cFile, 4) + " not found", ;
	cMess  := "Reading DBF structure"
#endif
  local aResult

  if ( File (cFile := AllTrim (cFile)) .or. File (cFile + ".DBF") )
    if ( OpenDbf (cFile, "FSELECT") )
      ClrMessage (cMess, 3)

      aResult := FSELECT->(DBStruct ())
      CloseDbf ("FSELECT")

      ClrWindow ()
    else
      ClrNetErr ()
    end
  else
    ClrMessage (cError, 1)
  end

return aResult


*******************************************************************************
*******************************************************************************
* EOF CLRDBF.PRG